:root {
	color-scheme: light dark;
	--bg-color: light-dark(#fff, hsl(0, 0%, 10%));
	--text-color: light-dark(#000, hsl(0, 0%, 90%));
	--open-settings-border-hover: light-dark(hsl(0, 0%, 80%), hsl(0, 0%, 25%));
	--open-settings-bg-hover: light-dark(hsl(0, 0%, 85%), hsl(0, 0%, 20%));
	--separator-border: light-dark(hsl(0, 0%, 50%), hsl(0, 0%, 50%));
	--chevron-color: light-dark(#000, #fff);
	--task-border: light-dark(hsl(0, 0%, 85%), hsl(0, 0%, 20%));
	--task-bg: light-dark(hsl(0, 0%, 90%), hsl(0, 0%, 15%));
	--task-group-text: light-dark(hsl(0, 0%, 40%), hsl(0, 0%, 60%));
	--task-group-border: light-dark(hsl(0, 0%, 77.5%), hsl(0, 0%, 22.5%));
	--task-group-bg: light-dark(hsl(0, 0%, 82.5%), hsl(0, 0%, 17.5%));
	--importance-text: light-dark(#d00, #f44);
	--input-bg: light-dark(hsl(0, 0%, 95%), hsl(0, 0%, 10%));
	--button-text: light-dark(#fff, #000);
	--button-bg: light-dark(hsl(0, 0%, 30%), hsl(0, 0%, 60%));
	--button-bg-hover: light-dark(hsl(0, 0%, 20%), hsl(0, 0%, 80%));
	--button-bg-disabled: light-dark(hsl(0, 0%, 70%), hsl(0, 0%, 30%));
	--clear-button-bg-hover: light-dark(#0002, #fff2);
	--danger-text: light-dark(#f00, #f22);
}

body {
	display: flex;
	flex-direction: column;
	align-items: center;
	color: var(--text-color);
	font-family: sans-serif;
	font-size: 16px;
	margin: 10px;
	background: var(--bg-color);
}

.light {
	color-scheme: light;
}

.dark {
	color-scheme: dark;
}

.body-container {
	width: 100%;
	max-width: 500px;
}

header {
	display: flex;
	justify-content: space-between;
	align-items: center;
	margin: 5px 0;
}

h1 {
	margin: 0;
}

h2 {
	margin: 0;
}

#open-settings {
	display: flex;
	justify-content: center;
	align-items: center;
	height: 2rem;
	aspect-ratio: 1;
	font-weight: bold;
	cursor: pointer;
	border: 2px solid var(--task-border);
	border-radius: 50%;
	background: var(--task-bg);
	transition: all 0.2s;
}

#open-settings:hover {
	border: 2px solid var(--open-settings-border-hover);
	background: var(--open-settings-bg-hover);
	transform-origin: center center;
	transform: rotate(45deg);
}

#open-settings img {
	width: 1.25rem;
}

.view-controls {
	display: flex;
	justify-content: flex-start;
	font-size: 1rem;
	margin-bottom: 8px;
	padding-top: 8px;
	border-top: 2px solid var(--separator-border);
}

.slimselect.ss-main {
	color: var(--text-color);
	font-size: 1rem;
	border: 2px solid var(--task-border);
	background: var(--task-bg);
}

.slimselect.ss-main.importance {
	text-align: center;
}

.slimselect.ss-main:focus {
	box-shadow: none;
	border: 2px solid light-dark(var(--task-border), #fff);
}

.ss-list {
	border: 2px solid var(--task-border) !important;
}

.ss-option.slimselect-option {
	color: var(--text-color) !important;
	border: none;
	background: var(--task-bg);
}

.ss-option.slimselect-option.importance {
	justify-content: center;
}

.ss-option.slimselect-option:hover {
	border: none !important;
	background: var(--task-border) !important;
	animation: none !important;
}

.ss-option.ss-selected {
	font-weight: bold;
	background: var(--task-border) !important;
}

#sort-by {
	margin-right: 10px;
}

#tasks {
	margin: 0;
	padding: 0;
	list-style-type: none;
	font-size: 1rem;
	width: 100%;
	border-top: 2px solid var(--separator-border);
	border-bottom: 2px solid var(--separator-border);
}

#tasks div.task-group-container {
	max-height: 10000px;
	overflow: hidden;
	transition: max-height 0.2s ease-out;
}

#tasks li.task {
	display: flex;
	justify-content: flex-start;
	align-items: center;
	gap: 0.5rem;
	margin: 10px 0;
	padding: 5px;
	border: 2px solid var(--task-border);
	border-radius: 5px;
	background: var(--task-bg);
	overflow-wrap: anywhere;

}

#tasks li.task.deleted {
	animation: delete 0.3s cubic-bezier(0.11, 0, 0.5, 0) forwards;
}

@keyframes delete {
	from {
		transform: translateX(0);
	}

	to {
		transform: translateX(-100%);
		opacity: 0;
	}
}

#tasks li.group-header {
	display: flex;
	justify-content: space-between;
	align-items: center;
	margin: 10px 0;
	padding: 5px;
	border: none;
	border-radius: 0;
	background: #0000;
}

#tasks li.group-header.folded {
	border-bottom: 2px solid var(--task-bg);
}

.fold-unfold-group {
	position: relative;
	display: flex;
	justify-content: space-between;
	align-items: center;
	width: 1.5rem;
	aspect-ratio: 1;
	background-color: #0000;
	transition: background-color 0.2s;
}

.arrow {
	position: relative;
	display: flex;
	justify-content: center;
	align-items: center;
	gap: 0.2rem;
	width: 100%;
	height: 100%;
	transform-origin: center center;
	transition: transform 0.3s ease;
}

.arrow-line {
	position: relative;
	width: 0.2rem;
	height: 0.7rem;
	border-radius: 0.15rem;
	background: var(--chevron-color);
	transform-origin: center center;
	transition: transform 0.3s ease;
}

.arrow-line.left {
	transform: rotate(-45deg);
}

.arrow-line.right {
	transform: rotate(45deg);
}

.folded .arrow {
	transform: rotate(-180deg);
}

.fold-unfold-group:hover {
	background-color: var(--clear-button-bg-hover);
}

#tasks li.group-header h2 {
	font-size: 1.1rem;
	font-weight: bold;
}

#tasks li .task-info {
	display: flex;
	flex-direction: column;
	align-items: flex-start;
	gap: 2px;
	padding: 5px;
}

#tasks li input.status {
	width: 1rem;
	height: 1rem;
	margin: 0 0 0 5px;
	padding: 0;
}

#tasks li:has(input.status:checked) span:not(.task-group, .task-importance, .delete) {
	text-decoration: line-through;
}

#tasks li span.task-name {
	padding: 2px;
}

#tasks li div.task-options {
	display: flex;
	align-items: stretch;
	gap: 5px;
}

#tasks li span.task-group {
	color: var(--task-group-text);
	font-size: 0.9rem;
	font-style: italic;
	cursor: text;
	padding: 2px;
	border: 2px solid var(--task-group-border);
	border-radius: 5px;
	background: var(--task-group-bg);
}

#tasks li input.task-due-date {
	color: var(--task-group-text);
	font-size: 0.9rem;
	font-style: italic;
	text-align: center;
	cursor: text;
	width: 6rem;
	padding: 2px;
	border: 2px solid var(--task-group-border);
	border-radius: 5px;
	background: var(--task-group-bg);
}

#tasks li span.task-group:empty:not(:focus) {
	padding: 5px;
}

#tasks li .task-controls {
	flex: 1;
	display: flex;
	justify-content: flex-end;
	gap: 10px;
}

#tasks li button.task-importance {
	color: var(--importance-text);
	font-size: 1rem;
	font-weight: bold;
	cursor: pointer;
	width: max-content;
	padding: 5px;
	border: 2px solid var(--task-group-border);
	border-radius: 5px;
	background: var(--task-group-bg);
}

.drop-down {
	color: var(--text-color);
	font-size: 1rem;
	position: fixed;
	display: flex;
	flex-direction: column;
	gap: 2px;
	border: 2px solid var(--task-border);
	border-radius: 5px;
	background: var(--task-border);
	z-index: 9990;
}

.drop-down .drop-down-option:first-child {
	border-radius: 5px 5px 0 0;
}

.drop-down .drop-down-option:last-child {
	border-radius: 0 0 5px 5px;
}

.drop-down .drop-down-option {
	cursor: pointer;
	padding: 5px;
	background: var(--task-bg);
}

.drop-down .drop-down-option:hover {
	background: var(--task-border);
}

#tasks li button.delete {
	margin: 0;
	padding: 0;
	cursor: pointer;
	border: none;
	border-radius: 0;
	background: #0000;
	visibility: hidden;
	transition: none;
}

#tasks li button.delete.always-show {
	visibility: visible;
}

#tasks li:hover button.delete {
	visibility: visible;
}

.add-task {
	display: flex;
	flex-direction: column;
	align-items: stretch;
	gap: 5px;
	margin: 10px 0;
}

input {
	font-size: 1rem;
	margin: 0;
	padding: 5px;
	border: 2px solid var(--task-border);
	border-radius: 5px;
	background: var(--input-bg);
}

#importance {
	text-align: center;
}

button {
	color: var(--button-text);
	font-size: 1rem;
	margin: 0;
	padding: 5px;
	border: none;
	border-radius: 5px;
	background: var(--button-bg);
	transition: background 0.2s;
}

button:hover {
	cursor: pointer;
	background: var(--button-bg-hover);
}

button:disabled {
	cursor: not-allowed;
	background: var(--button-bg-disabled);
}

.spinner {
	display: inline-block;
	height: calc(1rem - 4px);
	aspect-ratio: 1;
	margin: 0 auto;
	border: 4px solid rgba(0, 0, 0, 0.1);
	border-top-color: #fff;
	border-radius: 50%;
	animation: spin 0.8s linear infinite;
}

@keyframes spin {
	from {
		transform: rotate(0);
	}

	to {
		transform: rotate(360deg);
	}
}

.error-text:not(:empty) {
	color: #fff;
	font-size: 1rem;
	text-align: center;
	padding: 5px;
	border-radius: 5px;
	background: #f33;
}

#error-container {
	position: fixed;
	bottom: 10px;
	left: 0;
	display: flex;
	flex-direction: column;
	justify-content: flex-end;
	align-items: center;
	gap: 10px;
	width: calc(100vw - 20px);
	padding: 10px;
	z-index: 9999;
}

.toast-error {
	display: flex;
	justify-content: space-between;
	align-items: center;
	color: white;
	font-size: 1.2rem;
	width: calc(100% - 10px);
	max-width: 500px;
	padding: 5px;
	border-radius: 5px;
	background: #f33;
	box-shadow: 0 0 10px rgba(0, 0, 0, 0.5);
	animation: 1s linear 5s fade-out forwards;
}

.toast-error button.remove {
	color: inherit;
	font-weight: bold;
	cursor: pointer;
	margin-right: 5px;
	padding: 0;
	border: none;
	border-radius: 0;
	background: #0000;
	transition: none;
}

/* pause fade on hover so user can read error */
.toast-error:hover {
	animation-play-state: paused;
}

@keyframes fade-out {
	to {
		opacity: 0;
		display: none;
	}
}

dialog {
	width: calc(90% - 20px);
	max-width: 400px;
	margin: 100px auto 0 auto;
	padding: 10px;
	border: none;
	border-radius: 5px;
	background: var(--bg-color);
	box-shadow: 0 0 10px rgba(0, 0, 0, 0.5);
	outline: none;
}

dialog::backdrop {
	background: rgba(0, 0, 0, 0.75);
}

.dialog-flex {
	display: flex;
	flex-direction: column;
	gap: 5px;
}

dialog header {
	gap: 10px;
	margin: 0;
	padding-bottom: 5px;
	border-bottom: 2px solid var(--separator-border);
	font-size: 1.3rem;
}

dialog h1 {
	font-size: 1.7rem;
}

dialog h2 {
	font-size: 1.2rem;
	width: fit-content;
	margin: 10px 0 0 0;
}

#close-settings {
	background: #0000;
}

.setting {
	display: flex;
	justify-content: space-between;
	align-items: center;
	padding: 5px;
	border: 2px solid var(--task-border);
	border-radius: 5px;
	background: var(--task-bg);
}

button.setting {
	color: var(--text-color);
	padding: 5px;
	border: 2px solid var(--task-border);
	background: var(--task-bg);
}

button.setting:hover {
	background: var(--task-border);
}

button.setting:disabled {
	cursor: not-allowed;
	background: var(--task-bg);
}

.small-icon {
	font-size: 0.7rem;
}

.danger, .setting.danger {
	color: var(--danger-text);
}

.bold {
	font-weight: bold;
}

.slide-checkbox {
	display: none;
}

.slide-label {
	height: 1.3rem;
	aspect-ratio: 2;
	display: block;
	cursor: pointer;
	background: #c00;
	border-radius: 1.3rem;
	transition: background 0.3s;
}

.slide-label::before {
	content: "";
	display: block;
	height: 1rem;
	aspect-ratio: 1;
	border-radius: 50%;
	background: #fff;
	transform: translate(0.15rem, 0.15rem);
	transition: transform 0.3s;
}

#show-deletex:checked + #show-deletex-label {
	background: #0a0;
}

#show-deletex:checked + #show-deletex-label::before {
	transform: translate(1.45rem, 0.15rem);
}

.colour-theme-options {
	display: flex;
	align-items: center;
	gap: 5px;
}

#colour-theme-auto {
	color: var(--text-color);
	font-weight: bold;
	cursor: pointer;
	padding: 0;
	background: #0000;
}

#colour-theme-label {
	display: block;
	background: hsl(0, 0%, 70%);
}

#colour-theme:checked + #colour-theme-label {
	background: hsl(0, 0%, 30%);
}

#colour-theme:checked + #colour-theme-label::before {
	transform: translate(1.45rem, 0.15rem);
}

#change-pswd-dialog, #delete-account-dialog {
	margin-top: 150px;
}

.hidden {
	display: none;
}

#change-pswd-dialog > .dialog-flex h1 {
	margin-bottom: 10px;
}

.navigation-buttons {
	display: flex;
	align-items: stretch;
	gap: 5px;
}

.navigation-buttons button {
	width: 100%;
	margin-top: 20px;
}

.navigation-buttons .cancel-button {
	color: var(--button-bg);
	border: 2px solid var(--task-border);
	background: var(--task-bg);
}

.navigation-buttons .cancel-button:hover {
	background: var(--task-border);
}